###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2005 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
%define buildup 1
%define buildsmp 1
%define buildxen 1
%define kernel_version 2.6.11-1.1369_FC4
%define subversion 20050601.152643.FC4

%ifnarch i686 x86_64
%define buildsmp 0
%endif 

%ifnarch i686
%define buildxen 0
%endif 

Name: GFS-kernel
Version: 2.6.11.8
Release: %{subversion}.2
License: GPL
Group: System Environment/Kernel
Summary: GFS-kernel - The Global File System kernel modules
BuildRequires: gulm-devel dlm-devel dlm-kernheaders
BuildRequires: kernel = %{kernel_version}
BuildRequires: kernel-smp = %{kernel_version}
BuildRequires: kernel-devel = %{kernel_version}
BuildRequires: kernel-smp-devel = %{kernel_version}
BuildRequires: dlm-kernel
BuildRequires: dlm-kernel-smp
BuildRequires: dlm-kernheaders >= 2.6.11
BuildRequires: cman-kernheaders >= 2.6.11
Conflicts: GFS <= 6.0
Conflicts: GFS-modules
Requires: kernel = %{kernel_version}
Requires: /lib/modules/%{kernel_version}
Provides: kernel-modules
Provides: GFS-kernel-modules = %{version}-%{release}
ExclusiveArch: i586 i686 x86_64 ppc 
Source0: gfs-kernel-%{version}-%{subversion}.tar.gz

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
GFS - The Global File System is a symmetric, shared-disk, cluster file
system.

%package -n GFS-kernheaders
Group: Development/System
Summary: GFS kernel header files

%description -n GFS-kernheaders
The GFS kernel headers are used by the GFS tool set for compilation.

%if %{buildsmp}
%package -n GFS-kernel-smp
Group: System Environment/Kernel
Summary: GFS-kernel-smp - The Global File System kernel modules
Requires: kernel-smp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}smp
Provides: kernel-modules
Provides: GFS-kernel-modules = %{version}-%{release}
%description -n GFS-kernel-smp
GFS - The Global File System is a symmetric, shared-disk, cluster file
system.
%endif

%if %{buildxen}
%package -n GFS-kernel-xenU
Group: System Environment/Kernel
Summary: GFS-kernel-xenU - The Global File System kernel modules
Requires: kernel-xenU = %{kernel_version}
Requires: /lib/modules/%{kernel_version}xenU
Provides: kernel-modules
Provides: GFS-kernel-modules = %{version}-%{release}

%description -n GFS-kernel-xenU
GFS - The Global File System is a symmetric, shared-disk, cluster file
system.

%package -n GFS-kernel-xen0
Group: System Environment/Kernel
Summary: GFS-kernel-xen0 - The Global File System kernel modules
Requires: kernel-xen0 = %{kernel_version}
Requires: /lib/modules/%{kernel_version}xen0
Provides: kernel-modules
Provides: GFS-kernel-modules = %{version}-%{release}

%description -n GFS-kernel-xen0
GFS - The Global File System is a symmetric, shared-disk, cluster file
system.
%endif

################################################################################
##  THE PREP SECTION
################################################################################
%prep
%setup -q -n gfs-kernel-%{version}-%{subversion}
# Put the version information into the necessary files
sed  -i -e '/RELEASE_NAME/s/"<CVS>"/"%{version}-%{release}"/' \
	src/nolock/main.c src/gulm/gulm.h src/gfs/gfs.h src/harness/main.c 

################################################################################
##  THE BUILD SECTION
################################################################################
%build
BUILD_TOPDIR=`pwd`

cp -r `pwd` ../smp
cp -r `pwd` ../xenU
cp -r `pwd` ../xen0

Build_gfs(){
	cpu_type=$1
	flavor=$2
	kernel_src=/lib/modules/%{kernel_version}$flavor/build
	# Kernel tree setup
	if [ -d $kernel_src/. ]; then
		echo "Kernel %{kernel_version} found."
		echo $kernel_src
	else
		echo "Kernel %{kernel_version} not found."
		echo $kernel_src
		ls /lib/modules/*
		exit 1
	fi

        ./configure --kernel_src=$kernel_src --incdir=%{_includedir}
        if [ "$flavor" == "xenU" -o "$flavor" == "xen0" ]; then
	        make  %{?_smp_mflags} DLMSYMVERFILE=/lib/modules/%{kernel_version}$flavor/kernel/cluster/dlm.symvers ARCH=xen
        else
		make  %{?_smp_mflags} DLMSYMVERFILE=/lib/modules/%{kernel_version}$flavor/kernel/cluster/dlm.symvers
	fi

}

%if %{buildup}
Build_gfs %{_target_cpu}
%endif

%if %{buildsmp}
cd ../smp
Build_gfs %{_target_cpu} smp
%endif

%if %{buildxen}
cd ../xenU
Build_gfs %{_target_cpu} xenU
cd ../xen0
Build_gfs %{_target_cpu} xen0
%endif

################################################################################
##  THE INSTALL SECTION
################################################################################
%install
rm -rf $RPM_BUILD_ROOT

%if %{buildup}
make install DESTDIR=$RPM_BUILD_ROOT DLMSYMVERFILE=/lib/modules/%{kernel_version}/kernel/cluster/dlm.symvers
%endif
 
%if %{buildsmp}
cd ../smp
make install DESTDIR=$RPM_BUILD_ROOT DLMSYMVERFILE=/lib/modules/%{kernel_version}smp/kernel/cluster/dlm.symvers
%endif

%if %{buildxen}
cd ../xenU
make install DESTDIR=$RPM_BUILD_ROOT DLMSYMVERFILE=/lib/modules/%{kernel_version}xenU/kernel/cluster/dlm.symvers ARCH=xen
cd ../xen0
make install DESTDIR=$RPM_BUILD_ROOT DLMSYMVERFILE=/lib/modules/%{kernel_version}xen0/kernel/cluster/dlm.symvers ARCH=xen
%endif

################################################################################
##  THE CLEAN SECTION
################################################################################
%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/depmod -e %{kernel_version}

%if %{buildsmp}
%post smp
/sbin/depmod -e %{kernel_version}smp
%endif

%if %{buildxen}
%post xenU
/sbin/depmod -e %{kernel_version}xenU
%post xen0
/sbin/depmod -e %{kernel_version}xen0
%endif

%files
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}/kernel/fs/gfs
%dir /lib/modules/%{kernel_version}/kernel/fs/gfs_locking
%dir /lib/modules/%{kernel_version}/kernel/fs/gfs_locking/*
/lib/modules/%{kernel_version}/kernel/fs/gfs/*
/lib/modules/%{kernel_version}/kernel/fs/gfs_locking/*/*

%if %{buildsmp}
%files -n GFS-kernel-smp
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}smp/kernel/fs/gfs
%dir /lib/modules/%{kernel_version}smp/kernel/fs/gfs_locking
%dir /lib/modules/%{kernel_version}smp/kernel/fs/gfs_locking/*
/lib/modules/%{kernel_version}smp/kernel/fs/gfs/*
/lib/modules/%{kernel_version}smp/kernel/fs/gfs_locking/*/*
%endif

%if %{buildxen}
%files -n GFS-kernel-xenU
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}xenU/kernel/fs/gfs
%dir /lib/modules/%{kernel_version}xenU/kernel/fs/gfs_locking
%dir /lib/modules/%{kernel_version}xenU/kernel/fs/gfs_locking/*
/lib/modules/%{kernel_version}xenU/kernel/fs/gfs/*
/lib/modules/%{kernel_version}xenU/kernel/fs/gfs_locking/*/*
%files -n GFS-kernel-xen0
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}xen0/kernel/fs/gfs
%dir /lib/modules/%{kernel_version}xen0/kernel/fs/gfs_locking
%dir /lib/modules/%{kernel_version}xen0/kernel/fs/gfs_locking/*
/lib/modules/%{kernel_version}xen0/kernel/fs/gfs/*
/lib/modules/%{kernel_version}xen0/kernel/fs/gfs_locking/*/*
/lib/modules/%{kernel_version}xen0
%endif

%files -n GFS-kernheaders
%defattr(-,root,root,-)
%{_includedir}/linux/*

%changelog
* Mon May 23 2005 Chris Feist <cfeist@redhat.com>
- Fixed depmod in %post scriptlet to use correct kernel.

* Tue May 17 2005 Chris Feist <cfeist@redhat.com>
- Provides GFS-kernel-modules and add ARCH=xen to build.

* Mon May 16 2005 Chris Feist <cfeist@redhat.com>
- Add depmod in %post scriplet.

* Fri May 06 2005 Chris Feist <cfeist@redhat.com>
- Cleanup spec file and fix %files section.

* Tue May 03 2005 Chris Feist <cfeist@redhat.com>
- Build new sources and remove patch.

* Fri Apr 29 2005 Chris Feist <cfeist@redhat.com>
- Rebuild for new kernel
- Adding support for i586, xen0 & xenU

* Mon Dec 20 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel & upstream fixes.

* Fri Dec 10 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel & upstream fixes.

* Thu Nov 18 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Mon Nov 1 2004 Chris Feist <cfeist@redhat.com> 
- new upstream sources w/ fix for __you_cannot_kmalloc_that_much

* Mon Oct 25 2004 Chris Feist <cfeist@redhat.com> 
- new upstream sources

* Sat Aug 14 2004 Jon Brassow <jbrassow@redhat.com> 
- new upstream sources
- smp was building but not being packaged

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com> 
- add patch for make file

* Thu Jun 17 2004 Jon Brassow <jbrassow@redhat.com> 
- Initial build.
